## serd 0.30.6

=== wscript ===
#!/usr/bin/env python

import glob
import os
import sys

from waflib import Build, Logs, Options
from waflib.extras import autowaf

# Library and package version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
SERD_VERSION       = '0.30.6'
SERD_MAJOR_VERSION = '0'

# Mandatory waf variables
APPNAME = 'serd'        # Package name for waf dist
VERSION = SERD_VERSION  # Package version for waf dist
top     = '.'           # Source directory
out     = 'build'       # Build directory

# Release variables
uri          = 'http://drobilla.net/sw/serd'
dist_pattern = 'http://download.drobilla.net/serd-%d.%d.%d.tar.bz2'
post_tags    = ['Hacking', 'RDF', 'Serd']


def options(ctx):
    ctx.load('compiler_c')
    ctx.add_flags(
        ctx.configuration_options(),
        {'no-utils':     'do not build command line utilities',
         'stack-check':  'include runtime stack sanity checks',
         'static':       'build static library',
         'no-shared':    'do not build shared library',
         'static-progs': 'build programs as static binaries',
         'largefile':    'build with large file support on 32-bit systems',
         'no-posix':     'do not use POSIX functions, even if present'})


def configure(conf):
    conf.load('compiler_c', cache=True)
    conf.load('autowaf', cache=True)
    autowaf.set_c_lang(conf, 'c99')

    if Options.options.strict:
        # Check for programs used by lint target
        conf.find_program("flake8", var="FLAKE8", mandatory=False)
        conf.find_program("clang-tidy", var="CLANG_TIDY", mandatory=False)
        conf.find_program("iwyu_tool", var="IWYU_TOOL", mandatory=False)

    if Options.options.ultra_strict:
        autowaf.add_compiler_flags(conf.env, '*', {
            'clang': [
                '-Wno-cast-align',
                '-Wno-cast-qual',
                '-Wno-covered-switch-default',
                '-Wno-disabled-macro-expansion',
                '-Wno-double-promotion',
                '-Wno-format-nonliteral',
                '-Wno-implicit-fallthrough',
                '-Wno-padded',
                '-Wno-reserved-id-macro',
                '-Wno-sign-conversion',
            ],
            'gcc': [
                '-Wno-cast-align',
                '-Wno-cast-qual',
                '-Wno-float-conversion',
                '-Wno-inline',
                '-Wno-padded',
                '-Wno-sign-conversion',
                '-Wno-suggest-attribute=const',
                '-Wno-suggest-attribute=pure',
            ],
            'msvc': [
                '/wd4061',  # enumerator in switch is not explicitly handled
                '/wd4365',  # signed/unsigned mismatch
                '/wd4514',  # unreferenced inline function has been removed
                '/wd4710',  # function not inlined
                '/wd4711',  # function selected for automatic inline expansion
                '/wd4820',  # padding added after construct
                '/wd4996',  # POSIX name for this item is deprecated
            ],
        })

        autowaf.add_compiler_flags(conf.env, 'c', {
            'clang': [
                '-Wno-bad-function-cast',
            ],
            'gcc': [
                '-Wno-bad-function-cast',
                '-Wno-suggest-attribute=malloc'
            ],
            'msvc': [
                '/wd4706',  # assignment within conditional expression
                '/wd5045',  # will insert Spectre mitigation for memory load
            ],
        })

    conf.env.update({
        'BUILD_UTILS': not Options.options.no_utils,
        'BUILD_SHARED': not Options.options.no_shared,
        'STATIC_PROGS': Options.options.static_progs,
        'BUILD_STATIC': (Options.options.static or
                         Options.options.static_progs)})

    if not conf.env.BUILD_SHARED and not conf.env.BUILD_STATIC:
        conf.fatal('Neither a shared nor a static build requested')

    if Options.options.stack_check:
        conf.define('SERD_STACK_CHECK', SERD_VERSION)

    if Options.options.largefile:
        conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])

    if not Options.options.no_posix:
        funcs = {'posix_memalign': ('stdlib.h', 'int', 'void**,size_t,size_t'),
                 'posix_fadvise':  ('fcntl.h', 'int', 'int,off_t,off_t,int'),
                 'fileno':         ('stdio.h', 'int', 'FILE*')}

        for name, (header, ret, args) in funcs.items():
            conf.check_function('c', name,
                                header_name = header,
                                return_type = ret,
                                arg_types   = args,
                                define_name = 'HAVE_' + name.upper(),
                                defines     = ['_POSIX_C_SOURCE=200809L'],
                                mandatory   = False)

    autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
    conf.write_config_header('serd_config.h', remove=False)

    autowaf.display_summary(
        conf,
        {'Build static library': bool(conf.env['BUILD_STATIC']),
         'Build shared library': bool(conf.env['BUILD_SHARED']),
         'Build utilities':      bool(conf.env['BUILD_UTILS']),
         'Build unit tests':     bool(conf.env['BUILD_TESTS'])})


lib_headers = ['src/reader.h']

lib_source = ['src/base64.c',
              'src/byte_source.c',
              'src/env.c',
              'src/n3.c',
              'src/node.c',
              'src/reader.c',
              'src/string.c',
              'src/system.c',
              'src/uri.c',
              'src/writer.c']


def build(bld):
    # C Headers
    includedir = '${INCLUDEDIR}/serd-%s/serd' % SERD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('serd/*.h'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
                     {'SERD_MAJOR_VERSION': SERD_MAJOR_VERSION})

    defines = []
    lib_args = {'export_includes': ['.'],
                'includes':        ['.', './src'],
                'cflags':          ['-fvisibility=hidden'],
                'lib':             ['m'],
                'vnum':            SERD_VERSION,
                'install_path':    '${LIBDIR}'}
    if bld.env.MSVC_COMPILER:
        lib_args['cflags'] = []
        lib_args['lib']    = []
        defines            = []

    # Shared Library
    if bld.env.BUILD_SHARED:
        bld(features        = 'c cshlib',
            source          = lib_source,
            name            = 'libserd',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            defines         = defines + ['SERD_SHARED', 'SERD_INTERNAL'],
            **lib_args)

    # Static library
    if bld.env.BUILD_STATIC:
        bld(features        = 'c cstlib',
            source          = lib_source,
            name            = 'libserd_static',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            defines         = defines + ['SERD_INTERNAL'],
            **lib_args)

    if bld.env.BUILD_TESTS:
        coverage_flags = [''] if bld.env.NO_COVERAGE else ['--coverage']
        test_args = {'includes':     ['.', './src'],
                     'cflags':       coverage_flags,
                     'linkflags':    coverage_flags,
                     'lib':          lib_args['lib'],
                     'install_path': ''}

        # Profiled static library for test coverage
        bld(features     = 'c cstlib',
            source       = lib_source,
            name         = 'libserd_profiled',
            target       = 'serd_profiled',
            defines      = defines + ['SERD_INTERNAL'],
            **test_args)

        # Test programs
        for prog in [('serdi_static', 'src/serdi.c'),
                     ('env_test', 'tests/env_test.c'),
                     ('free_null_test', 'tests/free_null_test.c'),
                     ('read_chunk_test', 'tests/read_chunk_test.c'),
                     ('serd_test', 'tests/serd_test.c')]:
            bld(features     = 'c cprogram',
                source       = prog[1],
                use          = 'libserd_profiled',
                target       = prog[0],
                defines      = defines,
                **test_args)

    # Utilities
    if bld.env.BUILD_UTILS:
        obj = bld(features     = 'c cprogram',
                  source       = 'src/serdi.c',
                  target       = 'serdi',
                  includes     = ['.', './src'],
                  use          = 'libserd',
                  lib          = lib_args['lib'],
                  install_path = '${BINDIR}')
        if not bld.env.BUILD_SHARED or bld.env.STATIC_PROGS:
            obj.use = 'libserd_static'
        if bld.env.STATIC_PROGS:
            obj.env.SHLIB_MARKER = obj.env.STLIB_MARKER
            obj.linkflags        = ['-static']

    # Documentation
    if bld.env.DOCS:
        autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)
        bld(features='subst',
            source='doc/index.html.in',
            target='doc/index.html',
            install_path='',
            name='index',
            SERD_VERSION=SERD_VERSION)

    # Man page
    bld.install_files('${MANDIR}/man1', 'doc/serdi.1')

    bld.add_post_fun(autowaf.run_ldconfig)


class LintContext(Build.BuildContext):
    fun = cmd = 'lint'


def lint(ctx):
    "checks code for style issues"
    import subprocess

    st = 0

    if "FLAKE8" in ctx.env:
        Logs.info("Running flake8")
        st = subprocess.call([ctx.env.FLAKE8[0],
                              "wscript",
                              "--ignore",
                              "E101,E129,W191,E221,W504,E251,E241,E741"])
    else:
        Logs.warn("Not running flake8")

    if "IWYU_TOOL" in ctx.env:
        Logs.info("Running include-what-you-use")
        cmd = [ctx.env.IWYU_TOOL[0], "-o", "clang", "-p", "build"]
        output = subprocess.check_output(cmd).decode('utf-8')
        if 'error: ' in output:
            sys.stdout.write(output)
            st += 1
    else:
        Logs.warn("Not running include-what-you-use")

    if "CLANG_TIDY" in ctx.env and "clang" in ctx.env.CC[0]:
        Logs.info("Running clang-tidy")
        sources = glob.glob('src/*.c') + glob.glob('tests/*.c')
        sources = list(map(os.path.abspath, sources))
        procs = []
        for source in sources:
            cmd = [ctx.env.CLANG_TIDY[0], "--quiet", "-p=.", source]
            procs += [subprocess.Popen(cmd, cwd="build")]

        for proc in procs:
            stdout, stderr = proc.communicate()
            st += proc.returncode
    else:
        Logs.warn("Not running clang-tidy")

    if st != 0:
        sys.exit(st)


def amalgamate(ctx):
    "builds single-file amalgamated source"
    import shutil
    import re
    shutil.copy('serd/serd.h', 'build/serd.h')

    def include_line(line):
        return (not re.match(r'#include "[^/]*\.h"', line) and
                not re.match('#include "serd/serd.h"', line))

    with open('build/serd.c', 'w') as amalgamation:
        amalgamation.write('/* This is amalgamated code, do not edit! */\n')
        amalgamation.write('#include "serd.h"\n\n')

        for header_path in ['src/serd_internal.h',
                            'src/system.h',
                            'src/byte_sink.h',
                            'src/byte_source.h',
                            'src/stack.h',
                            'src/string_utils.h',
                            'src/uri_utils.h',
                            'src/reader.h']:
            with open(header_path) as header:
                for l in header:
                    if include_line(l):
                        amalgamation.write(l)

        for f in lib_headers + lib_source:
            with open(f) as fd:
                amalgamation.write('\n/**\n   @file %s\n*/' % f)

=== debian/changelog ===
serd (0.30.6-1) unstable; urgency=medium

  * New upstream version 0.30.6
  * Update patchset
    + Make the build reproducible. Thanks to Chris Lamb! (Closes: #968278)

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 29 Sep 2020 22:58:43 +0200

=== debian/control ===
Source: serd
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 python3:any
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 4.5.0
Homepage: https://drobilla.net/software/serd/
Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
Rules-Requires-Root: no

Package: libserd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libserd-0-0 (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 pkg-config
Suggests:
 libserd-doc
Description: lightweight RDF syntax library - development files
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the development files for Serd.

Package: libserd-0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 serdi
Description: lightweight RDF syntax library
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 Serd is not intended to be a swiss-army knife of RDF syntax, but rather
 is suited to resource limited applications, or situations where a simple
 reader/writer with minimal dependencies is ideal (e.g. in LV2 hosts or
 plugins).
 .
 Serd is:
  * small: Serd is implemented in under 2500 lines1 of standard C code.
  * portable and dependency-free: Serd uses only the C standard library,
    and has no external dependencies, making it a lightweight dependency
    in every sense.
  * fast and lightweight: Serd (and the included serdi tool) can be used
    to stream abbreviated Turtle (unlike many other tools which can not
    stream since they must first build an internal model to abbreviate).
    In other words, Serd can re-serialise an unbounded amount of Turtle
    using a fixed amount of memory, preserving the abbreviations in the
    input.
  * conformant and well-tested: Serd is written to the Turtle, NTriples
    and URI specifications, and includes a comprehensive test suite which
    includes all the normative examples from the Turtle specification, all
    the "normal" examples from the URI specification, and additional tests
    added specifically for Serd. The test suite has over 96% code coverage
    (by line), and runs with zero memory errors or leaks.

Package: serdi
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight RDF syntax library - serdi tool
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the utility 'serdi'.

Package: libserd-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Enhances:
 libserd-dev
Depends:
 libjs-jquery,
 ${misc:Depends}
Description: lightweight RDF syntax library - documentation
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the developer's reference for serd.

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.sig/,uversionmangle=s/-/./,dversionmangle=s/~dfsg.*//" \
https://download.drobilla.net/serd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## serd 0.30.8

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SERD_VERSION       = '0.30.6'
+SERD_VERSION       = '0.30.8'
 SERD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -42,7 +42,12 @@
 def configure(conf):
     conf.load('compiler_c', cache=True)
     conf.load('autowaf', cache=True)
-    autowaf.set_c_lang(conf, 'c99')
+
+    if conf.env.DOCS:
+        conf.load('sphinx')
+
+    if not autowaf.set_c_lang(conf, 'c11', mandatory=False):
+        autowaf.set_c_lang(conf, 'c99')
 
     if Options.options.strict:
         # Check for programs used by lint target
@@ -55,11 +60,14 @@
             'clang': [
                 '-Wno-cast-align',
                 '-Wno-cast-qual',
+                '-Wno-conversion',
                 '-Wno-covered-switch-default',
                 '-Wno-disabled-macro-expansion',
                 '-Wno-double-promotion',
                 '-Wno-format-nonliteral',
                 '-Wno-implicit-fallthrough',
+                '-Wno-nullability-extension',
+                '-Wno-nullable-to-nonnull-conversion',
                 '-Wno-padded',
                 '-Wno-reserved-id-macro',
                 '-Wno-sign-conversion',
@@ -71,8 +79,6 @@
                 '-Wno-inline',
                 '-Wno-padded',
                 '-Wno-sign-conversion',
-                '-Wno-suggest-attribute=const',
-                '-Wno-suggest-attribute=pure',
             ],
             'msvc': [
                 '/wd4061',  # enumerator in switch is not explicitly handled
@@ -91,13 +97,15 @@
             ],
             'gcc': [
                 '-Wno-bad-function-cast',
-                '-Wno-suggest-attribute=malloc'
             ],
             'msvc': [
                 '/wd4706',  # assignment within conditional expression
                 '/wd5045',  # will insert Spectre mitigation for memory load
             ],
         })
+
+        if 'mingw' in conf.env.CC[0]:
+            conf.env.append_value('CFLAGS', '-Wno-unused-macros')
 
     conf.env.update({
         'BUILD_UTILS': not Options.options.no_utils,
@@ -114,6 +122,13 @@
 
     if Options.options.largefile:
         conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])
+
+    conf.check_function('c', 'aligned_alloc',
+                        header_name = 'stdlib.h',
+                        return_type = 'void*',
+                        arg_types   = 'size_t,size_t',
+                        define_name = 'HAVE_ALIGNED_ALLOC',
+                        mandatory   = False)
 
     if not Options.options.no_posix:
         funcs = {'posix_memalign': ('stdlib.h', 'int', 'void**,size_t,size_t'),
@@ -129,8 +144,18 @@
                                 defines     = ['_POSIX_C_SOURCE=200809L'],
                                 mandatory   = False)
 
-    autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
-    conf.write_config_header('serd_config.h', remove=False)
+    # Set up environment for building/using as a subproject
+    autowaf.set_lib_env(conf, 'serd', SERD_VERSION,
+                        include_path=str(conf.path.find_node('include')))
+
+    if conf.env.BUILD_TESTS:
+        serdi_node = conf.path.get_bld().make_node('serdi_static')
+    else:
+        serdi_node = conf.path.get_bld().make_node('serdi')
+
+    conf.env.SERDI = [serdi_node.abspath()]
+
+    conf.define('SERD_NO_DEFAULT_CONFIG', 1)
 
     autowaf.display_summary(
         conf,
@@ -157,15 +182,15 @@
 def build(bld):
     # C Headers
     includedir = '${INCLUDEDIR}/serd-%s/serd' % SERD_MAJOR_VERSION
-    bld.install_files(includedir, bld.path.ant_glob('serd/*.h'))
+    bld.install_files(includedir, bld.path.ant_glob('include/serd/*.h'))
 
     # Pkgconfig file
     autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
                      {'SERD_MAJOR_VERSION': SERD_MAJOR_VERSION})
 
     defines = []
-    lib_args = {'export_includes': ['.'],
-                'includes':        ['.', './src'],
+    lib_args = {'export_includes': ['include'],
+                'includes':        ['include'],
                 'cflags':          ['-fvisibility=hidden'],
                 'lib':             ['m'],
                 'vnum':            SERD_VERSION,
@@ -181,7 +206,7 @@
             source          = lib_source,
             name            = 'libserd',
             target          = 'serd-%s' % SERD_MAJOR_VERSION,
-            defines         = defines + ['SERD_SHARED', 'SERD_INTERNAL'],
+            defines         = defines + ['SERD_INTERNAL'],
             **lib_args)
 
     # Static library
@@ -190,12 +215,12 @@
             source          = lib_source,
             name            = 'libserd_static',
             target          = 'serd-%s' % SERD_MAJOR_VERSION,
-            defines         = defines + ['SERD_INTERNAL'],
+            defines         = defines + ['SERD_STATIC', 'SERD_INTERNAL'],
             **lib_args)
 
     if bld.env.BUILD_TESTS:
         coverage_flags = [''] if bld.env.NO_COVERAGE else ['--coverage']
-        test_args = {'includes':     ['.', './src'],
+        test_args = {'includes':     ['include'],
                      'cflags':       coverage_flags,
                      'linkflags':    coverage_flags,
                      'lib':          lib_args['lib'],
@@ -206,20 +231,23 @@
             source       = lib_source,
             name         = 'libserd_profiled',
             target       = 'serd_profiled',
-            defines      = defines + ['SERD_INTERNAL'],
+            defines      = defines + ['SERD_STATIC', 'SERD_INTERNAL'],
             **test_args)
 
         # Test programs
         for prog in [('serdi_static', 'src/serdi.c'),
-                     ('env_test', 'tests/env_test.c'),
-                     ('free_null_test', 'tests/free_null_test.c'),
-                     ('read_chunk_test', 'tests/read_chunk_test.c'),
-                     ('serd_test', 'tests/serd_test.c')]:
+                     ('test_env', 'test/test_env.c'),
+                     ('test_free_null', 'test/test_free_null.c'),
+                     ('test_node', 'test/test_node.c'),
+                     ('test_read_chunk', 'test/test_read_chunk.c'),
+                     ('test_reader_writer', 'test/test_reader_writer.c'),
+                     ('test_string', 'test/test_string.c'),
+                     ('test_uri', 'test/test_uri.c')]:
             bld(features     = 'c cprogram',
                 source       = prog[1],
                 use          = 'libserd_profiled',
                 target       = prog[0],
-                defines      = defines,
+                defines      = defines + ['SERD_STATIC'],
                 **test_args)
 
     # Utilities
@@ -227,7 +255,7 @@
         obj = bld(features     = 'c cprogram',
                   source       = 'src/serdi.c',
                   target       = 'serdi',
-                  includes     = ['.', './src'],
+                  includes     = ['include'],
                   use          = 'libserd',
                   lib          = lib_args['lib'],
                   install_path = '${BINDIR}')
@@ -239,13 +267,7 @@
 
     # Documentation
     if bld.env.DOCS:
-        autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)
-        bld(features='subst',
-            source='doc/index.html.in',
-            target='doc/index.html',
-            install_path='',
-            name='index',
-            SERD_VERSION=SERD_VERSION)
+        bld.recurse('doc/c')
 
     # Man page
     bld.install_files('${MANDIR}/man1', 'doc/serdi.1')
@@ -269,6 +291,10 @@
                               "wscript",
                               "--ignore",
                               "E101,E129,W191,E221,W504,E251,E241,E741"])
+        st += subprocess.call([ctx.env.FLAKE8[0],
+                               "scripts/serd_bench.py",
+                               "--ignore",
+                               "E203"])
     else:
         Logs.warn("Not running flake8")
 
@@ -284,7 +310,9 @@
 
     if "CLANG_TIDY" in ctx.env and "clang" in ctx.env.CC[0]:
         Logs.info("Running clang-tidy")
-        sources = glob.glob('src/*.c') + glob.glob('tests/*.c')
+        sources = glob.glob('include/serd/*.h*')
+        sources += glob.glob('src/*.c')
+        sources += glob.glob('test/*.c')
         sources = list(map(os.path.abspath, sources))
         procs = []
         for source in sources:
@@ -305,29 +333,3 @@
     "builds single-file amalgamated source"
     import shutil
     import re
-    shutil.copy('serd/serd.h', 'build/serd.h')
-
-    def include_line(line):
-        return (not re.match(r'#include "[^/]*\.h"', line) and
-                not re.match('#include "serd/serd.h"', line))
-
-    with open('build/serd.c', 'w') as amalgamation:
-        amalgamation.write('/* This is amalgamated code, do not edit! */\n')
-        amalgamation.write('#include "serd.h"\n\n')
-
-        for header_path in ['src/serd_internal.h',
-                            'src/system.h',
-                            'src/byte_sink.h',
-                            'src/byte_source.h',
-                            'src/stack.h',
-                            'src/string_utils.h',
-                            'src/uri_utils.h',
-                            'src/reader.h']:
-            with open(header_path) as header:
-                for l in header:
-                    if include_line(l):
-                        amalgamation.write(l)
-
-        for f in lib_headers + lib_source:
-            with open(f) as fd:
-                amalgamation.write('\n/**\n   @file %s\n*/' % f)

=== debian/changelog ===
serd (0.30.8-1) unstable; urgency=medium

  * New upstream version 0.30.8
  * Disable html doc build for now, missing sphinx_lv2_theme
  * Revert jquery.js linking
  * Bump S-V to 4.5.1, no changes needed
  * Refresh 1001-dont_run_ldconfig.patch
  * Drop 1002-reproducible-build.patch, obsolete now
  * d/rules: Fix the include of buildtools.mk
  * d/watch: Update pgpsigurlmangle for asc files
  * d/watch: Remove uversionmangle & dversionmangle, not needed

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 13 Jan 2021 22:42:05 +0100

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
  debhelper-compat (= 13),
  pkg-config,
  python3:any
-Build-Depends-Indep:
- doxygen,
- graphviz
-Standards-Version: 4.5.0
+#Build-Depends-Indep:
+# doxygen,
+# graphviz
+Standards-Version: 4.5.1
 Homepage: https://drobilla.net/software/serd/
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
@@ -91,7 +91,6 @@
 Enhances:
  libserd-dev
 Depends:
- libjs-jquery,
  ${misc:Depends}
 Description: lightweight RDF syntax library - documentation
  Serd is a lightweight C library for RDF syntax which supports reading

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export LINKFLAGS += $(LDFLAGS)

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk
PKG_CONFIG ?= pkg-config

WAF = python3 ./waf

# the documentation can not be build atm, because of missing 'sphinx_lv2_theme'
#ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
#CONFIGURE_EXTRA_FLAGS += --docs
#endif

%:
	dh $@

override_dh_auto_configure:
	CC="$(CC)" PKGCONFIG="$(PKG_CONFIG)" $(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--strict \
		$(CONFIGURE_EXTRA_FLAGS)

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	rm -rf build .waf*
	rm -rf .lock-*_build
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
https://download.drobilla.net/serd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## serd 0.30.10

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SERD_VERSION       = '0.30.8'
+SERD_VERSION       = '0.30.10'
 SERD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -123,13 +123,6 @@
     if Options.options.largefile:
         conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])
 
-    conf.check_function('c', 'aligned_alloc',
-                        header_name = 'stdlib.h',
-                        return_type = 'void*',
-                        arg_types   = 'size_t,size_t',
-                        define_name = 'HAVE_ALIGNED_ALLOC',
-                        mandatory   = False)
-
     if not Options.options.no_posix:
         funcs = {'posix_memalign': ('stdlib.h', 'int', 'void**,size_t,size_t'),
                  'posix_fadvise':  ('fcntl.h', 'int', 'int,off_t,off_t,int'),
@@ -267,6 +260,7 @@
 
     # Documentation
     if bld.env.DOCS:
+        bld.env.SERD_MAJOR_VERSION = SERD_MAJOR_VERSION
         bld.recurse('doc/c')
 
     # Man page
@@ -333,3 +327,9 @@
     "builds single-file amalgamated source"
     import shutil
     import re
+    shutil.copy('serd/serd.h', 'build/serd.h')
+
+    def include_line(line):
+        return (not re.match(r'#include "[^/]*\.h"', line) and
+                not re.match('#include "serd/serd.h"', line))
+

=== doc/c/wscript ===
#!/usr/bin/env python

def build(bld):
    dox_to_sphinx = bld.path.find_node("../../scripts/dox_to_sphinx.py")
    index_xml = bld.path.get_bld().make_node("xml/index.xml")

    files = [
        ("../../resources/serd.svg", "sphinx/_static/serd.svg"),
        ("../summary.rst", "sphinx/summary.rst"),
        ("index.rst", "sphinx/index.rst"),
        ("overview.rst", "sphinx/overview.rst"),
    ]

    # Run Doxygen to generate XML documentation
    bld(features="doxygen", doxyfile="Doxyfile")

    # Substitute variables to make Sphinx configuration file
    bld(features="subst",
        source="../conf.py.in",
        target="sphinx/conf.py",
        SERD_VERSION=bld.env.SERD_VERSION)

    # Copy static documentation files to Sphinx build directory
    for f in files:
        bld(features="subst", is_copy=True, source=f[0], target=f[1])

    # Generate Sphinx markup from Doxygen XML
    bld.add_group()
    bld(rule="${PYTHON} " + dox_to_sphinx.abspath() + " -f ${SRC} ${TGT}",
        source=index_xml,
        target="sphinx/api/")

    doc_dir = bld.env.DOCDIR + "/serd-%s/" % bld.env.SERD_MAJOR_VERSION

    # Run Sphinx to generate HTML documentation
    for builder in ["html", "singlehtml"]:
        bld(features="sphinx",
            sphinx_source=bld.path.get_bld().make_node("sphinx"),
            sphinx_output_format=builder,
            sphinx_options=["-E", "-q", "-t", builder],
            install_path=doc_dir + "c/%s/" % builder)

=== debian/changelog ===
serd (0.30.10-2) unstable; urgency=medium

  * Move python3-sphinx to Build-Depends-Indep to fix Cross-Build
    (Closes: #983378) Thx to Nilesh!

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 29 Apr 2021 21:30:07 +0200

serd (0.30.10-1) unstable; urgency=medium

  * New upstream version 0.30.10
  * Re-enable and fix doc installation
  * Refresh ldconfig patch
  * Link js files from libjs-sphinxdoc & libjs-underscore
    to not install duplicates
  * Fix lintian-overrides
  * d/watch: Use pgpmode=auto instead of pgpsigurlmangle

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 23 Jan 2021 01:21:34 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,10 @@
  debhelper-compat (= 13),
  pkg-config,
  python3:any
-#Build-Depends-Indep:
-# doxygen,
-# graphviz
+Build-Depends-Indep:
+ doxygen,
+ graphviz,
+ python3-sphinx
 Standards-Version: 4.5.1
 Homepage: https://drobilla.net/software/serd/
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
@@ -91,6 +92,7 @@
 Enhances:
  libserd-dev
 Depends:
+ libjs-sphinxdoc (>= 3.4.3-1),
  ${misc:Depends}
 Description: lightweight RDF syntax library - documentation
  Serd is a lightweight C library for RDF syntax which supports reading

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,9 @@
 
 WAF = python3 ./waf
 
-# the documentation can not be build atm, because of missing 'sphinx_lv2_theme'
-#ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
-#CONFIGURE_EXTRA_FLAGS += --docs
-#endif
+ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
+CONFIGURE_EXTRA_FLAGS += --docs
+endif
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="pgpmode=auto" \
https://download.drobilla.net/serd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## serd 0.30.12

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SERD_VERSION       = '0.30.10'
+SERD_VERSION       = '0.30.12'
 SERD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -61,11 +61,9 @@
                 '-Wno-cast-align',
                 '-Wno-cast-qual',
                 '-Wno-conversion',
-                '-Wno-covered-switch-default',
                 '-Wno-disabled-macro-expansion',
                 '-Wno-double-promotion',
                 '-Wno-format-nonliteral',
-                '-Wno-implicit-fallthrough',
                 '-Wno-nullability-extension',
                 '-Wno-nullable-to-nonnull-conversion',
                 '-Wno-padded',
@@ -86,6 +84,7 @@
                 '/wd4514',  # unreferenced inline function has been removed
                 '/wd4710',  # function not inlined
                 '/wd4711',  # function selected for automatic inline expansion
+                '/wd4800',  # implicit conversion from int to bool
                 '/wd4820',  # padding added after construct
                 '/wd4996',  # POSIX name for this item is deprecated
             ],
@@ -235,7 +234,8 @@
                      ('test_read_chunk', 'test/test_read_chunk.c'),
                      ('test_reader_writer', 'test/test_reader_writer.c'),
                      ('test_string', 'test/test_string.c'),
-                     ('test_uri', 'test/test_uri.c')]:
+                     ('test_uri', 'test/test_uri.c'),
+                     ('test_writer', 'test/test_writer.c')]:
             bld(features     = 'c cprogram',
                 source       = prog[1],
                 use          = 'libserd_profiled',

=== debian/changelog ===
serd (0.30.12-1) unstable; urgency=medium

  * New upstream version 0.30.12
  * Bump Standards Version to 4.6.1
  * d/copyright: Bump year and add myself
  * Fix spelling error in man page occured -> occurred
  * Add salsa ci config

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 30 May 2022 23:18:52 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  doxygen,
  graphviz,
  python3-sphinx
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://drobilla.net/software/serd/
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd

## serd 0.30.14

=== meson_options.txt ===
option('docs', type: 'feature', value: 'auto', yield: true,
       description: 'Build documentation')

option('static', type: 'boolean', value: false, yield: true,
       description: 'Statically link executables')

option('strict', type: 'boolean', value: false, yield: true,
       description: 'Enable ultra-strict warnings')

option('tests', type: 'feature', value: 'auto', yield: true,
       description: 'Build tests')

option('title', type: 'string', value: 'Serd',
       description: 'Project title')

option('tools', type: 'feature', value: 'auto', yield: true,
       description: 'Build command line utilities')

=== debian/changelog ===
serd (0.30.14-1) unstable; urgency=medium

  * New upstream version 0.30.14
  * Build with meson
  * Drop obsolete ldconfig patch
  * Fix doc installation
  * Refresh lintian-overrides
  * d/copyright: Drop waf entry and BSD license
  * Remove obsolete d/clean

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 25 Jul 2022 14:55:30 +0200

## serd 0.30.16

=== meson_options.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+# Copyright 2021-2022 David Robillard <d@drobilla.net>
+# SPDX-License-Identifier: 0BSD OR ISC
+
 option('docs', type: 'feature', value: 'auto', yield: true,
        description: 'Build documentation')

=== debian/changelog ===
serd (0.30.16-1) unstable; urgency=medium

  * New upstream version 0.30.16
  * Drop spelling error patch applied by upstream

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 12 Sep 2022 23:10:04 +0200

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  Dennis Braun <d_braun@kabelmail.de>
 Build-Depends:
  debhelper-compat (= 13),
+ meson,
  pkg-config,
  python3:any
 Build-Depends-Indep:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export LINKFLAGS += $(LDFLAGS)

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk
PKG_CONFIG ?= pkg-config

ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
CONFIG += docs
endif

CONFIG += strict

%:
	dh $@ --buildsystem=meson

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## serd 0.32.0

=== debian/changelog ===
serd (0.32.0-2) unstable; urgency=medium

  * Team upload
  * debian/rules: Really fix build of documentation

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 11 Nov 2023 00:20:54 +0100

serd (0.32.0-1) unstable; urgency=medium

  * Team upload
  * New upstream version 0.32.0
  * debian/control:
    - Update Homepage
    - Bump Standards-Version
    - Add sphinxygen to Build-Depends
  * debian/libserd-0-0.symbols: Add new symbol
  * debian/rules: Fix build of documentation

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 10 Nov 2023 23:53:29 +0100

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,10 @@
 Build-Depends-Indep:
  doxygen,
  graphviz,
- python3-sphinx
-Standards-Version: 4.6.1
-Homepage: https://drobilla.net/software/serd/
+ python3-sphinx,
+ sphinxygen
+Standards-Version: 4.6.2
+Homepage: https://drobilla.net/software/serd.html
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
 Rules-Requires-Root: no

## serd 0.32.2

=== meson_options.txt ===
# Copyright 2021-2023 David Robillard <d@drobilla.net>
# SPDX-License-Identifier: 0BSD OR ISC

option('checks', type: 'feature', value: 'enabled', yield: true,
       description: 'Check for platform-specific features')

option('docs', type: 'feature', value: 'auto', yield: true,
       description: 'Build documentation')

option('html', type: 'feature', value: 'auto', yield: true,
       description: 'Build paginated HTML documentation')

option('lint', type: 'boolean', value: false, yield: true,
       description: 'Run code quality checks')

option('man', type: 'feature', value: 'enabled', yield: true,
       description: 'Install man pages')

option('man_html', type: 'feature', value: 'auto', yield: true,
       description: 'Build HTML man pages')

option('singlehtml', type: 'feature', value: 'auto', yield: true,
       description: 'Build single-page HTML documentation')

option('static', type: 'boolean', value: false, yield: true,
       description: 'Statically link executables')

option('tests', type: 'feature', value: 'auto', yield: true,
       description: 'Build tests')

option('title', type: 'string', value: 'Serd',
       description: 'Project title')

option('tools', type: 'feature', value: 'auto', yield: true,
       description: 'Build command line utilities')

=== debian/changelog ===
serd (0.32.2-1) unstable; urgency=medium

  * New upstream version 0.32.2
  * Update d/copyright years and files
  * Change my email address

 -- Dennis Braun <snd@debian.org>  Wed, 24 Jan 2024 17:38:42 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>,
- Dennis Braun <d_braun@kabelmail.de>
+ Dennis Braun <snd@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  meson,

## serd 0.32.4

=== meson_options.txt ===
# Copyright 2021-2023 David Robillard <d@drobilla.net>
# SPDX-License-Identifier: 0BSD OR ISC

option('checks', type: 'feature', value: 'enabled', yield: true,
       description: 'Check for platform-specific features')

option('docs', type: 'feature', yield: true,
       description: 'Build documentation')

option('html', type: 'feature', yield: true,
       description: 'Build paginated HTML documentation')

option('lint', type: 'boolean', value: false, yield: true,
       description: 'Run code quality checks')

option('man', type: 'feature', value: 'enabled', yield: true,
       description: 'Install man pages')

option('man_html', type: 'feature', yield: true,
       description: 'Build HTML man pages')

option('singlehtml', type: 'feature', yield: true,
       description: 'Build single-page HTML documentation')

option('static', type: 'boolean', value: false, yield: true,
       description: 'Statically link executables')

option('tests', type: 'feature', yield: true,
       description: 'Build tests')

option('title', type: 'string', value: 'Serd',
       description: 'Project title')

option('tools', type: 'feature', yield: true,
       description: 'Build command line utilities')

=== debian/changelog ===
serd (0.32.4-1) unstable; urgency=medium

  * New upstream version 0.32.4
  * Change B-D and Depends for the dev package from pkg-config to pkgconf
  * Bump Standards-Version to 4.7.0
  * Bump d/copyright years

 -- Dennis Braun <snd@debian.org>  Sun, 09 Feb 2025 11:32:57 +0100

=== debian/control ===
--- 
+++ 
@@ -9,14 +9,14 @@
 Build-Depends:
  debhelper-compat (= 13),
  meson,
- pkg-config,
+ pkgconf,
  python3:any
 Build-Depends-Indep:
  doxygen,
  graphviz,
  python3-sphinx,
  sphinxygen
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://drobilla.net/software/serd.html
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
@@ -30,7 +30,7 @@
  libserd-0-0 (= ${binary:Version}),
  ${misc:Depends}
 Recommends:
- pkg-config
+ pkgconf
 Suggests:
  libserd-doc
 Description: lightweight RDF syntax library - development files

## serd 0.32.6

=== meson_options.txt ===
# Copyright 2021-2025 David Robillard <d@drobilla.net>
# SPDX-License-Identifier: 0BSD OR ISC

option('checks', type: 'feature', value: 'enabled',
       description: 'Check for platform-specific features')

option('docs', type: 'feature',
       description: 'Build documentation')

option('html', type: 'feature',
       description: 'Build paginated HTML documentation')

option('lint', type: 'boolean', value: false,
       description: 'Run code quality checks')

option('man', type: 'feature', value: 'enabled',
       description: 'Install man pages')

option('man_html', type: 'feature',
       description: 'Build HTML man pages')

option('singlehtml', type: 'feature',
       description: 'Build single-page HTML documentation')

option('static', type: 'boolean', value: false,
       description: 'Statically link executables')

option('tests', type: 'feature',
       description: 'Build tests')

option('title', type: 'string', value: 'Serd',
       description: 'Project title')

option('tools', type: 'feature',
       description: 'Build command line utilities')

=== debian/changelog ===
serd (0.32.6-1) unstable; urgency=medium

  * New upstream version 0.32.6
  * Update d/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove redudant rules-requires-root-no field

 -- Dennis Braun <snd@debian.org>  Tue, 18 Nov 2025 16:20:40 +0100

=== debian/control ===
--- 
+++ 
@@ -16,11 +16,10 @@
  graphviz,
  python3-sphinx,
  sphinxygen
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://drobilla.net/software/serd.html
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
-Rules-Requires-Root: no
 
 Package: libserd-dev
 Section: libdevel

=== debian/watch ===
Version: 5
Pgp-Mode: auto
Source: https://download.drobilla.net/
Matching-Pattern: @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## serd 0.32.8

=== debian/changelog ===
serd (0.32.8-1) unstable; urgency=medium

  * New upstream version 0.32.8
  * Remove redundant-priority-optional-field
  * Bump Standards-Version to 4.7.3
  * Bump d/copyright years

 -- Dennis Braun <snd@debian.org>  Sun, 01 Mar 2026 19:42:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: serd
 Section: libs
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
@@ -16,7 +15,7 @@
  graphviz,
  python3-sphinx,
  sphinxygen
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://drobilla.net/software/serd.html
 Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
